/*
 * Copyright (C) 2015-present, Ant Financial Services Group
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.alipay.hulu.shared.event.constant;

/**
 * Created by qiaoruikai on 2018/10/9 5:11 PM.
 */
public class Constant {
    /**
     * 触摸位置
     */
    public static final String EVENT_TOUCH_POSITION = "touchPosition";

    /**
     * 触摸设备X factor
     */
    public static final String EVENT_TOUCH_DEVICE_FACTOR_X = "deviceFactorX";

    /**
     * 触摸设备Y factor
     */
    public static final String EVENT_TOUCH_DEVICE_FACTOR_Y = "deviceFactorY";

    /**
     * 触摸设备
     */
    public static final String EVENT_TOUCH_DEVICE = "touchDevice";

    /**
     * 手指抬起
     */
    public static final String EVENT_TOUCH_UP = "touchUp";

    /**
     * 手指放下
     */
    public static final String EVENT_TOUCH_DOWN = "touchDown";

    /**
     * 辅助功能事件
     */
    public static final String EVENT_ACCESSIBILITY_EVENT = "accessibilityEvent";

    /**
     * 辅助功能手势
     */
    public static final String EVENT_ACCESSIBILITY_GESTURE = "accessibilityGesture";

    /**
     * 辅助功能手势
     */
    public static final String EVENT_ACCESSIBILITY_MODE = "accessibilityMode";

    /**
     * 辅助功能节点
     */
    public static final String KEY_ACCESSIBILITY_NODE = "accessibilityNode";

    /**
     * 辅助功能节点
     */
    public static final String KEY_ACCESSIBILITY_TYPE = "accessibilityType";

    /**
     * 辅助功能来源
     */
    public static final String KEY_ACCESSIBILITY_SOURCE = "accessibilitySource";

    /**
     * 辅助功能手势类型
     */
    public static final String KEY_GESTURE_TYPE = "gestureType";

    /**
     * 触摸位置
     */
    public static final String KEY_TOUCH_POINT = "touchPoint";
}
